using System;
using System.ComponentModel;

namespace IgSample
{

    public class MetaData : BaseNotifyPropertyChanged
    {
        private DataItem _item;

        public MetaData(DataItem item)
        {
            _item = item;
            IsValid = _item.Property3;
            _item.PropertyChanged += Item_PropertyChanged;
        }

        private void Item_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            if (e.PropertyName == "Property3")
            {
                if (_item.Property3 != IsValid)
                {
                    IsValid = _item.Property3;
                    RaisePropertyChanged("IsValid");
                }
            }
        }

        public bool IsValid { get; private set; }
    }

    public class DataItem : BaseNotifyPropertyChanged
    {
        public MetaData MetaData { get; set; }

        public DataItem()
        {
        }

        private string _property1;
        public string Property1
        {
            get { return _property1; }
            set
            {
                if (_property1 != value)
                {
                    _property1 = value;
                    RaisePropertyChanged("Property1");
                }
            }
        }

        private string _property2;
        public string Property2
        {
            get { return _property2; }
            set
            {
                if (_property2 != value)
                {
                    _property2 = value;
                    RaisePropertyChanged("Property2");
                }
            }
        }

        private bool _property3;
        public bool Property3
        {
            get { return _property3; }
            set
            {
                if (_property3 != value)
                {
                    _property3 = value;
                    RaisePropertyChanged("Property3");
                }
            }
        }



    }
}